/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"


#include <stdio.h>
#include <stdlib.h>                         /* free() exit() */
#include <string.h>
#include <assert.h>
#include <time.h>

#include "../../src/initng_handler.h"
#include "../../src/initng_global.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_common.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_static_data_id.h"
#include "../../src/initng_static_process_types.h"
#include "../../src/initng_static_states.h"
#include "../../src/initng_service.h"
#include "../../src/initng_execute.h"
#include "../../src/initng_process_db.h"

#include "initng_daemon_clean.h"

ptype_h T_DAEMON_CLEAN = { "daemon_clean", NULL };

static int on_kill(active_db_h * service, process_h *process);

static int on_kill(active_db_h * s, process_h *p)
{
    if(s->type != &TYPE_DAEMON && p->pt != &T_DAEMON)
	return(FALSE);

    /* start the T_DAEMON_CLEAN */	
    W_("%s %s has been killed!, executing DAEMON_CLEAN!\n", p->pt->name, s->name);
    initng_execute_launch(s, &T_DAEMON_CLEAN);

    /*
     * if we return TRUE, other kill handlers wont get this signal, 
     * it meens that this signal have been handled.
     */
    return(FALSE);
}


int module_init(const char *version)
{
    D_("module_init();\n");
    if (strcmp(version, INITNG_VERSION) != 0)
    {
        F_("This module is compiled for \"%s\" version and initng is compiled on \"%s\" version, won't load this module!\n", INITNG_VERSION, version);
        return (FALSE);
    }

    initng_process_db_ptype_add(&T_DAEMON_CLEAN);
    initng_plugin_hook_add(HANDLE_KILLED, 5, &on_kill);
    return (TRUE);
}

void module_unload(void)
{
    D_("module_unload();\n");
    initng_plugin_hook_del(HANDLE_KILLED, &on_kill);
    initng_process_db_ptype_del(&T_DAEMON_CLEAN);
}
