/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"


#include <stdio.h>
#include <string.h>                         /* strstr() */
#include <stdlib.h>                         /* free() exit() */
#include "../../src/initng_handler.h"
#include "../../src/initng_global.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_common.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_load_module.h"
#include "../../src/initng_static_states.h"

#include "initng_interactive.h"

static int active;


static int interactive_STARTING(active_db_h * service, a_state_h * status)
{
    char asw[10];

    asw[0] = '\0';

    fprintf(stderr, "Start service %s, (Y/n/a):", service->name);
    /* HACK: ignore read errors by assuming 'n' */
    if (fgets(asw, 9, stdin) == NULL)
        asw[0] = 'n';

    /* if it is true, then its ok to launch service */
    if (asw[0] == 'y' || asw[0] == 'Y')
        return (TRUE);

    if (asw[0] == 'a' || asw[0] == 'A')
    {
        initng_unload_module_named("interactive");
        return (TRUE);
    }

    initng_common_mark_service(service, &FAIL_STARTING);
    return (FALSE);

}

static int interactive_STOP_MARKED(active_db_h * service, a_state_h * status)
{
    char asw[10];

    asw[0] = '\0';

    fprintf(stderr, "Stop service %s, (Y/n/a):", service->name);
    /* HACK: ignore read errors by assuming 'n' */
    if (fgets(asw, 9, stdin) == NULL)
        asw[0] = 'n';

    if (asw[0] == 'y' || asw[0] == 'Y')
        return (TRUE);

    if (asw[0] == 'a' || asw[0] == 'A')
        initng_unload_module_named("interactive");

    initng_common_mark_service(service, &FAIL_STOPPING);
    return (FALSE);

}


int module_init(const char *version)
{
    int i;

    if (strcmp(version, INITNG_VERSION) != 0)
    {
        F_("This module is compiled for \"%s\" version and initng is compiled on \"%s\" version, won't load this module!\n", INITNG_VERSION, version);
        return (FALSE);
    }
    D_("module_init();\n");
    for (i = 0; g.Argv[i]; i++)
        if (strstr(g.Argv[i], "interactive"))
        {
            P_("Initng is started in interactive mode!\n");
            initng_active_state_add_test(&STARTING, 30,
                                         &interactive_STARTING);
            initng_active_state_add_test(&STOP_MARKED, 30,
                                         &interactive_STOP_MARKED);
            active = TRUE;
            return (TRUE);
        }

    active = FALSE;
    initng_unload_module_named("interactive");
    return (TRUE);
}

void module_unload(void)
{
    D_("module_unload();\n");
    if (active == TRUE)
    {
        initng_active_state_del_test(&STARTING, interactive_STARTING);
        initng_active_state_del_test(&STOP_MARKED, interactive_STOP_MARKED);
    }
}
